#!/usr/bin/python
# -*- encoding: utf-8 -*-
###############################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) OpenERP Venezuela (<http://www.vauxoo.com>).
#    All Rights Reserved
############# Credits #########################################################
#    Coded by: Katherine Zaoral <kathy@vauxoo.com>
#    Planified by: Humberto Arocha <hbto@vauxoo.com>
#    Audited by: Humberto Arocha <hbto@vauxoo.com>
###############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
###############################################################################

from openerp.osv import fields, osv, orm
from openerp.tools.translate import _
from openerp import tools


class purchase_order(osv.Model):
    _inherit = 'purchase.order'
    _columns = {
        'date_contract_expiry': fields.date(
            'Expiration of Contract Date',
            help='Expiration of Contract Date'),
    }

    def _prepare_order_picking(self, cur, uid, order, context=None):
        """
        Overwirthe the method that create the values for the picking creation
        and add the purchase order date_contract_expiry field to the stock
        picking element.
        """
        context = context or {}
        res = super(purchase_order, self)._prepare_order_picking(
            cur, uid, order, context=context)
        res['date_contract_expiry'] = order.date_contract_expiry
        return res
